@echo off
set ARGS=%*
set ADBPATH=bin\adb

REM ## initialize
cd "%~dp0"
if not exist tmp mkdir tmp
if exist tmp\_win.bat del tmp\_win.bat
if exist tmp\_script.sh del tmp\_script.sh
title FRepݒc[(win)
%ADBPATH% kill-server
%ADBPATH% start-server > NUL

REM ## check Android version and USB debug connection
:CHECKOSVER
set ANDROIDVER=0
setlocal ENABLEDELAYEDEXPANSION
set /A SDKNUM=0
for /F "usebackq tokens=*" %%i in (`%ADBPATH% %ARGS% shell getprop ro.build.version.sdk 2^>^&1`) do (
  if "%%i"=="error: more than one device/emulator" (
    goto MULTI
  ) else if "%%i"=="error: no devices/emulators found" (
    echo error: device not found.
    goto FAILED
  ) else if "%%i"=="error: device offline" (
    goto OFFLINE
  ) else (
REM ## for matching; find returns ERRORLEVEL 0 for success
    echo %%i | find "error: device unauthorized" > NUL
    if not ERRORLEVEL 1 (
      goto OFFLINE
    )
REM ## skip version check on permission denied / not found
    echo %%i | find "permission denied" > NUL
    if not ERRORLEVEL 1 (
      goto START
    )
    echo %%i | find "not found" > NUL
    if not ERRORLEVEL 1 (
      goto START
    )
REM ## check SDK version
    set /A SDKNUM=%%i+0
    if "!SDKNUM!"=="0" (
REM ## not a number / unknown error.
      goto FAILED
    )
    goto START
  )
)
:START
endlocal & set ANDROIDVER=%SDKNUM%

REM ## branch by Android version 4.4(19) or later
if %ANDROIDVER% geq 19 (
  echo Android 4.4ȍ~̂win_alt.bats܂.
REM ## start in same cmd window
  win_alt.bat %ARGS%
  exit /b
)

set DEFPUSHPATH=/data/data/com.x0.strai.frep/app_bin/setup.sh
set PUSHPATH=%DEFPUSHPATH%
:PUSH
%ADBPATH% %ARGS% push bin\setup.sh %PUSHPATH%
REM ## if failed to push, with permission denied, retry with another path
if ERRORLEVEL 1 (
  for /F "usebackq tokens=*" %%i in (`%ADBPATH% %ARGS% push bin\setup.sh %PUSHPATH% 2^>^&1`) do (
    echo %%i | find "denied" > NUL
    if not ERRORLEVEL 1 (
      if %PUSHPATH%==%DEFPUSHPATH% (
        REM ## retry with tmp dir
        set PUSHPATH=/data/local/tmp/setup.sh
        goto PUSH
      )
    )
  )
  goto FAILED
)

echo sh %PUSHPATH% ^& > tmp\_script.sh
echo @echo off > tmp\_win.bat
echo title Server Started.ƕ\ꂽEBhEĂ >> tmp\_win.bat
echo echo Permission Denied ƕ\ꂽꍇwin_alt.batsĂ >> tmp\_win.bat
echo %ADBPATH% %ARGS% shell ^< tmp\_script.sh >> tmp\_win.bat

:STARTBAT
title ob`WuI܂Hƕ\ꂽNĂ(adbI܂)
start /wait call tmp\_win.bat
%ADBPATH% kill-server
exit /b

:OFFLINE
set /P TMP="Android@ɕ\ĂUSBfobOĂEnterL[Ă.(~Ctrl+C) "
goto CHECKOSVER

:MULTI
setlocal ENABLEDELAYEDEXPANSION
REM # requires for counting in loop
set /A DEVNUM=0
echo Android@킪ڑĂ܂.
for /F "usebackq tokens=*" %%i in (`%ADBPATH% devices -l`) do (
  if not "%%i"=="" (
REM # ignore header; find returns ERRORLEVEL=0 for success
    echo %%i | find "List of devices attached" > NUL
    if ERRORLEVEL 1 (
      echo [!DEVNUM!] %%i
    )
    set /A DEVNUM=!DEVNUM!+1
  )
)
set /P SELNUM="ݒ肷@̔ԍ͂Ă.(0ŃLZ):"
REM set zero for non-numeric value
set /A SELNUM=%SELNUM%+0
set /A DEVNUM=0
set SELDEVICE=
set SAMPLEDEVICE=00000000

for /F "usebackq tokens=1" %%i in (`%ADBPATH% devices`) do (
  if not "%%i"=="" (
REM # ignore header; find returns ERRORLEVEL=0 for success
    echo %%i | find "List" > NUL
    if ERRORLEVEL 1 (
	  if "!DEVNUM!"=="%SELNUM%" (
        set SELDEVICE=%%i
		goto SELECTED
	  ) else if "%SAMPLEDEVICE%"=="00000000" (
	    set SAMPLEDEVICE=%%i
	  )
    )
    set /A DEVNUM=!DEVNUM!+1
  )
)
:SELECTED
if "%SELDEVICE%"=="" (
  echo ݒ肷@1̂ݐڑԂōēxs邩A邢͐ݒ肷@1
  echo IvV -s ^(LVA1^) Ŏw肵Ă.
  echo ^) win -s %SAMPLEDEVICE%
  pause
  %ADBPATH% kill-server
  exit /b 1
)
echo [%SELNUM%] %SELDEVICE% I܂.
endlocal & set ARGS=-s %SELDEVICE%
goto CHECKOSVER

:FAILED
echo ݒɎs܂. ȉ̓_mFčĂт̃XNvgsĂ.
echo 1.Android̐ݒJUSBfobOONɂĂ.
echo 2.AndroidňxFRepNĂȂꍇ́AFRepNĂ.
echo 肪Ȃꍇ́ALT|[gy[WFAQQƂĂ.
echo http://strai.x0.com/frep-ja/faq#setup
pause
%ADBPATH% kill-server
exit /b
